diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
index 9f3b9809b..00d1ccab2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicLayerSnow.java
@@ -2,12 +2,14 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.block.material.Materials;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
+import net.minecraft.core.item.block.ItemBlockLayerSnow;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.biome.BiomeTags;
@@ -20,12 +22,14 @@ import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
-public class BlockLogicLayerSnow extends BlockLogicLayerSupportable {
+public class BlockLogicLayerSnow extends BlockLogicLayerSupportable implements BlockLogic.MatcherDataEquivalency.Masked {
+    public static final int MASK_PERMANENT = 0b1000_0000;
 
-    public BlockLogicLayerSnow(@NotNull Block<? extends BlockLogicLayerBase> block, @NotNull Block<?> fullBlock, @NotNull Material material) {
+    public BlockLogicLayerSnow(@NotNull Block<? extends BlockLogicLayerSnow> block, @NotNull Block<?> fullBlock, @NotNull Material material) {
         super(block, fullBlock, material);
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
         block.setTicking(true);
+        block.setBlockItem(() -> new ItemBlockLayerSnow<>(block));
     }
 
     public void accumulate(@NotNull World world, @NotNull TilePosc tilePos) {
@@ -51,16 +55,19 @@ public class BlockLogicLayerSnow extends BlockLogicLayerSupportable {
 
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+        int layers = (data & MASK_HEIGHT) + 1;
         return switch (dropCause) {
-            case SILK_TOUCH -> new ItemStack[]{new ItemStack(this, data + 1)};
+            case SILK_TOUCH -> new ItemStack[]{new ItemStack(this, layers)};
             case PICK_BLOCK -> new ItemStack[]{new ItemStack(this)};
-            case EXPLOSION, PROPER_TOOL -> new ItemStack[]{new ItemStack(Items.AMMO_SNOWBALL, data + 1)};
+            case EXPLOSION, PROPER_TOOL -> new ItemStack[]{new ItemStack(Items.AMMO_SNOWBALL, layers)};
             default -> null;
         };
     }
 
     @Override
     public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (isPermanent(world.getBlockData(tilePos))) return;
+
         if (world.getSavedLightValue(LightLayer.Block, tilePos) > 11) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockTypeNotify(tilePos, Blocks.AIR);
@@ -70,4 +77,26 @@ public class BlockLogicLayerSnow extends BlockLogicLayerSupportable {
             world.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
+
+    @Override
+    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
+        return MASK_PERMANENT;
+    }
+
+    public static boolean isPermanent(int meta) {
+        return (meta & MASK_PERMANENT) != 0;
+    }
+
+    public static int setPermanent(int meta, boolean flag) {
+        if (flag) {
+            return meta | MASK_PERMANENT;
+        } else {
+            return meta & ~MASK_PERMANENT;
+        }
+    }
+
+    @Override
+    public int getMatcherDataEquivalencyMask() {
+        return ~MASK_PERMANENT;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
index 599e968d3..413bfe898 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
@@ -17,7 +17,6 @@ import net.minecraft.core.entity.Entity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.BoundingVolume;
 import net.minecraft.core.util.phys.HitResult;
@@ -232,7 +231,7 @@ public class BlockLogicStairs extends BlockLogic implements BlockLogic.MatcherDa
         @Nullable HitResult closest = null;
         double closestDistSq = Double.POSITIVE_INFINITY;
         for (AABBd part : stairLocalParts(hRotation, stepYOffset)) {
-            @Nullable HitResult hit = traceRayAgainstLocalAabb(tilePos, start, end, part);
+            @Nullable HitResult hit = traceRayAgainstLocalAABB(tilePos, start, end, part);
             if (hit != null) {
                 double d2 = start.distanceSquared(hit.location);
                 if (d2 < closestDistSq) {
@@ -376,105 +375,4 @@ public class BlockLogicStairs extends BlockLogic implements BlockLogic.MatcherDa
         return this.modelBlock.getMaterialColor();
     }
 
-    private static @Nullable HitResult traceRayAgainstLocalAabb(@NotNull TilePosc tilePos, @NotNull Vector3dc start, @NotNull Vector3dc end, @NotNull AABBdc bounds) {
-        double px = tilePos.x();
-        double py = tilePos.y();
-        double pz = tilePos.z();
-        Vector3d startInBlock = start.add(-px, -py, -pz, new Vector3d());
-        Vector3d endInBlock = end.add(-px, -py, -pz, new Vector3d());
-
-        @Nullable Vector3d minVX = MathHelper.vecClipX(startInBlock, endInBlock, bounds.minX(), new Vector3d());
-        @Nullable Vector3d maxVX = MathHelper.vecClipX(startInBlock, endInBlock, bounds.maxX(), new Vector3d());
-        @Nullable Vector3d minVY = MathHelper.vecClipY(startInBlock, endInBlock, bounds.minY(), new Vector3d());
-        @Nullable Vector3d maxVY = MathHelper.vecClipY(startInBlock, endInBlock, bounds.maxY(), new Vector3d());
-        @Nullable Vector3d minVZ = MathHelper.vecClipZ(startInBlock, endInBlock, bounds.minZ(), new Vector3d());
-        @Nullable Vector3d maxVZ = MathHelper.vecClipZ(startInBlock, endInBlock, bounds.maxZ(), new Vector3d());
-
-        if (!isVecInsideYzBounds(bounds, minVX)) minVX = null;
-        if (!isVecInsideYzBounds(bounds, maxVX)) maxVX = null;
-        if (!isVecInsideXzBounds(bounds, minVY)) minVY = null;
-        if (!isVecInsideXzBounds(bounds, maxVY)) maxVY = null;
-        if (!isVecInsideXyBounds(bounds, minVZ)) minVZ = null;
-        if (!isVecInsideXyBounds(bounds, maxVZ)) maxVZ = null;
-
-        @Nullable Vector3d clip = null;
-        @Nullable Side side = null;
-        double bestD2 = Double.POSITIVE_INFINITY;
-
-        if (minVX != null) {
-            double d2 = startInBlock.distanceSquared(minVX);
-            if (d2 < bestD2) {
-                bestD2 = d2;
-                clip = minVX;
-                side = Side.WEST;
-            }
-        }
-        if (maxVX != null) {
-            double d2 = startInBlock.distanceSquared(maxVX);
-            if (d2 < bestD2) {
-                bestD2 = d2;
-                clip = maxVX;
-                side = Side.EAST;
-            }
-        }
-        if (minVY != null) {
-            double d2 = startInBlock.distanceSquared(minVY);
-            if (d2 < bestD2) {
-                bestD2 = d2;
-                clip = minVY;
-                side = Side.BOTTOM;
-            }
-        }
-        if (maxVY != null) {
-            double d2 = startInBlock.distanceSquared(maxVY);
-            if (d2 < bestD2) {
-                bestD2 = d2;
-                clip = maxVY;
-                side = Side.TOP;
-            }
-        }
-        if (minVZ != null) {
-            double d2 = startInBlock.distanceSquared(minVZ);
-            if (d2 < bestD2) {
-                bestD2 = d2;
-                clip = minVZ;
-                side = Side.NORTH;
-            }
-        }
-        if (maxVZ != null) {
-            double d2 = startInBlock.distanceSquared(maxVZ);
-            if (d2 < bestD2) {
-                bestD2 = d2;
-                clip = maxVZ;
-                side = Side.SOUTH;
-            }
-        }
-
-        if (clip == null) {
-            return null;
-        }
-
-        return new HitResult.Tile(tilePos, side, clip.add(px, py, pz, new Vector3d()));
-    }
-
-    private static boolean isVecInsideYzBounds(AABBdc bounds, @Nullable Vector3dc v) {
-        if (v == null) {
-            return false;
-        }
-        return v.y() >= bounds.minY() && v.y() <= bounds.maxY() && v.z() >= bounds.minZ() && v.z() <= bounds.maxZ();
-    }
-
-    private static boolean isVecInsideXzBounds(AABBdc bounds, @Nullable Vector3dc v) {
-        if (v == null) {
-            return false;
-        }
-        return v.x() >= bounds.minX() && v.x() <= bounds.maxX() && v.z() >= bounds.minZ() && v.z() <= bounds.maxZ();
-    }
-
-    private static boolean isVecInsideXyBounds(AABBdc bounds, @Nullable Vector3dc v) {
-        if (v == null) {
-            return false;
-        }
-        return v.x() >= bounds.minX() && v.x() <= bounds.maxX() && v.y() >= bounds.minY() && v.y() <= bounds.maxY();
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
index e32728ada..3b136a987 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
@@ -26,6 +26,7 @@ import java.util.List;
 import java.util.function.Supplier;
 
 public class BlockLogicStatue extends BlockLogic implements BlockLogic.MatcherEntityEquivalency<TileEntityStatue> {
+    private static final float HALF_WIDTH = 5.0f / 16.0f;
     private final boolean isBottom;
 
     public final @Nullable Supplier<@NotNull Item> droppedItem;
@@ -42,8 +43,7 @@ public class BlockLogicStatue extends BlockLogic implements BlockLogic.MatcherEn
 
         final float bottom = this.isBottom ? 0.0f : -1.0f;
         final float top = this.isBottom ? 2.0f : 1.0f;
-        setBlockBounds(0.0f, bottom, 0.0f, 1.0f, top, 1.0f);
-
+        setBlockBounds(0.5f - HALF_WIDTH, bottom, 0.5f - HALF_WIDTH, 0.5f + HALF_WIDTH, top, 0.5f + HALF_WIDTH);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWorkbench.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWorkbench.java
index 5489d4f55..2c1e97e7c 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicWorkbench.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicWorkbench.java
@@ -8,7 +8,7 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockLogicWorkbench extends BlockLogic {
+public class BlockLogicWorkbench extends BlockLogicRotatable {
 
     public BlockLogicWorkbench(@NotNull Block<?> block) {
         super(block, Materials.WOOD);
diff --git a/game/core/src/main/java/net/minecraft/core/block/Blocks.java b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
index d8009b276..c78a3e4f8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Blocks.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Blocks.java
@@ -1054,7 +1054,7 @@ public final class Blocks {
         .withSound(BlockSounds.STONE).withHardness(1.5F).withBlastResistance(10F).withLitInteriorSurface(true)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE);
     public static final @NotNull Block<BlockLogicLayerAsh> LAYER_ASH = register("layer.ash", "minecraft:block/layer_ash", 723, (BlockLogicSupplier<BlockLogicLayerAsh>)(b) -> new BlockLogicLayerAsh(b, Blocks.BLOCK_ASH, Materials.TOP_ASH))
-        .withSound(BlockSounds.CLOTH).withHardness(0.1F).withLitInteriorSurface(true)
+        .withSound(BlockSounds.SAND).withHardness(0.1F).withLitInteriorSurface(true)
         .withTags(BlockTags.BROKEN_BY_FLUIDS, BlockTags.PLACE_OVERWRITES, BlockTags.MINEABLE_BY_SHOVEL, BlockTags.OVERRIDE_STEPSOUND);
 
     public static final @NotNull Block<?> ICE = register("ice", "minecraft:block/ice", 730, BlockLogicIce::new)
@@ -1068,7 +1068,7 @@ public final class Blocks {
         .withSound(BlockSounds.CLOTH).withHardness(0.2F)
         .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_SHOVEL, BlockTags.FIREFLIES_CAN_SPAWN);
     public static final @NotNull Block<?> BLOCK_ASH = register("block.ash", "minecraft:block/block_ash", 741, BlockLogicAsh::new)
-        .withSound(BlockSounds.CLOTH).withHardness(0.2F)
+        .withSound(BlockSounds.SAND).withHardness(0.2F)
         .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.MINEABLE_BY_SHOVEL);
 
     public static final @NotNull Block<?> CACTUS = register("cactus", "minecraft:block/cactus", 750, BlockLogicCactus::new)
@@ -1374,7 +1374,7 @@ public final class Blocks {
     public static final Block<?> GLOOMSTONE = register("gloomstone", "minecraft:block/gloomstone", 1032, (b) -> new BlockLogicStone(b, Blocks.COBBLE_GLOOMSTONE, Materials.GLOOMSTONE))
         .withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
         .withTags(BlockTags.CAVES_CUT_THROUGH, BlockTags.NETHER_MOBS_SPAWN, BlockTags.NETHER_SURFACE_BLOCK, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CAVES_CUT_THROUGH);
-    public static final Block<?> COBBLE_GLOOMSTONE = register("cobble.gloomstone", "minecraft:block/cobble_gloomstone", 1033, (b) -> new BlockLogicCobble(b, Materials.GLOOMSTONE, null))
+    public static final Block<?> COBBLE_GLOOMSTONE = register("cobble.gloomstone", "minecraft:block/cobble_gloomstone", 1033, (b) -> new BlockLogicCobble(b, Materials.GLOOMSTONE, () -> Blocks.BLOCK_ASH))
         .withSound(BlockSounds.STONE).withHardness(2.0F).withBlastResistance(10F)
         .withTags(BlockTags.MINEABLE_BY_PICKAXE, BlockTags.CHAINLINK_FENCES_CONNECT, BlockTags.CAVES_CUT_THROUGH);
     public static final Block<?> BRICK_GLOOMSTONE = register("brick.gloomstone", "minecraft:block/brick_gloomstone", 1034, (b) -> new BlockLogic(b, Materials.GLOOMSTONE))
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 06ce3d305..51a312c6d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -678,6 +678,9 @@ public abstract class Entity
             this.isWalking = this.walkDistO != this.walkDist;
 
             if (canInteract()) {
+                if ((float) this.nextStep > this.walkDist + 1.0F) {
+                    this.nextStep = (int) this.walkDist + 1;
+                }
                 int walkedSteps = (int) (this.walkDist - this.nextStep);
                 if (walkedSteps > 0 && blockWalkedOn != null) {
                     this.nextStep += walkedSteps;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
index 9f1ca5610..9e292b369 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityItem.java
@@ -8,6 +8,8 @@ import net.minecraft.core.Global;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicFluid;
+import net.minecraft.core.block.BlockLogicFluidStill;
 import net.minecraft.core.block.BlockLogicLog;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityMesh;
@@ -135,14 +137,17 @@ public class EntityItem extends Entity
         final @NotNull Block<?> blockUnderItem = this.world.getBlockType(tilePosUnderItem);
         final @NotNull Block<?> blockItemIsIn = this.world.getBlockType(tilePosItemIsInside);
 
-        boolean isInFlowingWater = false;
-        if(blockItemIsIn == Blocks.FLUID_WATER_STILL)
+        //Water, lava and acid all share the same buoyancy/friction behavior for now
+        final BlockLogicFluid fluidItemIsIn = blockItemIsIn.getLogic() instanceof BlockLogicFluidStill logic ? logic : null;
+
+        boolean isInFlowingLiquid = false;
+        if(fluidItemIsIn != null)
         {
-            isInFlowingWater = Blocks.FLUID_WATER_STILL.getLogic().hasFlowVector(this.world, new TilePos(this.x, this.y, this.z));
+            isInFlowingLiquid = fluidItemIsIn.hasFlowVector(this.world, tilePosItemIsInside);
         }
 
-        handleFriction(blockUnderItem, blockItemIsIn, isInFlowingWater);
-        handleBuoyancy(blockUnderItem, tilePosUnderItem, isInFlowingWater);
+        handleFriction(blockUnderItem, isInFlowingLiquid);
+        handleBuoyancy(blockUnderItem, tilePosUnderItem, fluidItemIsIn, isInFlowingLiquid);
 
         this.xo = this.x;
         this.yo = this.y;
@@ -339,7 +344,7 @@ public class EntityItem extends Entity
     	}
     }
 
-    private void handleFriction(@NotNull Block<?> blockUnderItem, @NotNull Block<?> blockItemIsIn, boolean isInFlowingWater){
+    private void handleFriction(@NotNull Block<?> blockUnderItem, boolean isInFlowingLiquid){
 
         //All mentions of friction in comments use the ENGLISH sense of the word, as for some reason
         //  adding friction to any value in game actually LOWERS the literal friction the item is receiving, and vice versa
@@ -357,9 +362,9 @@ public class EntityItem extends Entity
         //Items in streams of water get their friction set to the block underneath them/the stream.
         //All blocks get are given significantly less friction, and ice is given slightly less friction to
         //  improve the efficiency/speed of each respective water stream
-        if(isInFlowingWater)
+        if(isInFlowingLiquid)
         {
-            if(blockUnderItem != Blocks.FLUID_WATER_STILL)
+            if(!(blockUnderItem.getLogic() instanceof BlockLogicFluidStill))
             {
                 friction = blockUnderItem.friction;
             }
@@ -380,20 +385,21 @@ public class EntityItem extends Entity
 
     }
 
-    private void handleBuoyancy(Block<?> blockUnderItem, TilePos tilePosUnderItem, boolean inFlowingLiquid){
-
-        double midpoint = this.y % 1d + 0.14;
-        float fluidHeight = Blocks.FLUID_WATER_STILL.getLogic().getFluidHeight(this.world, new TilePos(this.x, this.y, this.z));
+    private void handleBuoyancy(Block<?> blockUnderItem, TilePos tilePosUnderItem, BlockLogicFluid fluidItemIsIn, boolean inFlowingLiquid){
 
-        //Adjust the height at which the item believes itself to be in the water for buoyancy purposes
+        //Adjust the height at which the item believes itself to be in the fluid for buoyancy purposes
         //  (so that the bobbing height is closer to the center of its bb)
-        boolean isInWater = false;
-        if(fluidHeight > midpoint || fluidHeight == 1){
-            isInWater = this.isInWater();
+        boolean isInFluid = false;
+        if(fluidItemIsIn != null){
+            double midpointOffset = (this.y - Math.floor(this.y)) + 0.14;
+            float fluidHeight = fluidItemIsIn.getFluidHeight(this.world, new TilePos(this.x, this.y, this.z));
+            if(fluidHeight > midpointOffset || fluidHeight == 1){
+                isInFluid = this.world.isMaterialInBB(this.bb, fluidItemIsIn.getMaterial());
+            }
         }
 
         //self-explanatory :wolfblock:
-        if (isInWater)
+        if (isInFluid)
         {
             //gradually slows the item down laterally
             this.xd *= 0.98f;
@@ -419,9 +425,15 @@ public class EntityItem extends Entity
                     }
                 }
             }
-            this.yd -= 0.02D;
+
+            //in a stream, sink slightly so items fall through gaps instead of floating over them
+            if(inFlowingLiquid)
+            {
+                this.yd -= 0.02D;
+            }
         }
-        //gravity out of water
+
+        //gravity out of fluid
         else
         {
             this.yd -= 0.04D;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 153d56e63..76df3b522 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -936,19 +936,6 @@ public abstract class Mob extends Entity {
             this.newPosRotationIncrements--;
             setPos(d, d1, d2);
             setRot(this.yRot, this.xRot);
-            List<AABBdc> list1 = this.world.getCubes(this, MathHelper.aabbInsetBoundingBox(this.bb, 0.03125D, 0.0D, 0.03125D, new AABBd()));
-            if (!list1.isEmpty()) {
-                double d4 = 0.0D;
-                for (int j = 0; j < list1.size(); j++) {
-                    AABBdc aabb = list1.get(j);
-                    if (aabb.maxY() > d4) {
-                        d4 = aabb.maxY();
-                    }
-                }
-
-                d1 += d4 - this.bb.minY;
-                setPos(d, d1, d2);
-            }
         }
         if (isMovementBlocked()) {
             this.isJumping = false;
@@ -1060,6 +1047,8 @@ public abstract class Mob extends Entity {
         boolean inAcid = isInAcid();
         if (inWater || inLava || inAcid) {
             this.isJumping = this.random.nextFloat() < 0.8F;
+        } else {
+            this.isJumping = false;
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
index 26ae0ce10..dfa5d25d7 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
@@ -102,6 +102,7 @@ public class MobPig
     private static final float PANIC_MOVE_SPEED = 1.3f;
     private static final int PANIC_DURATION_TICKS = 60;
     private int panicTicks = 0;
+    private boolean sitWhenBackOnLand = false;
 
     public float lookFadeAlpha = 1.0f;
     public long lookFadeLastRenderNanos = 0L;
@@ -114,6 +115,7 @@ public class MobPig
         if (passenger != null) {
             setSitting(false);
             this.panicTicks = 0;
+            this.sitWhenBackOnLand = false;
         }
         if (passenger == null) {
             this.xd = 0.0D;
@@ -206,9 +208,6 @@ public class MobPig
 
     @Override
     public boolean hurt(Entity attacker, int damage, DamageType type) {
-        if (attacker != null && attacker == this.passenger) {
-            return false;
-        }
         boolean hurt = super.hurt(attacker, damage, type);
         if (hurt) {
             this.speedProgress = 0f;
@@ -362,7 +361,15 @@ public class MobPig
         } else {
             this.footSize = 0.5f;
             this.moveSpeed = NORMAL_MOVE_SPEED;
+            if (getSitting() && isInWater()) {
+                setSitting(false);
+                this.sitWhenBackOnLand = true;
+            }
             super.updateAI();
+            if (this.sitWhenBackOnLand && getSaddled() && this.onGround && !isInWater()) {
+                this.sitWhenBackOnLand = false;
+                setSitting(true);
+            }
         }
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index a06599cbe..63e154732 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -52,6 +52,7 @@ import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.ICarriable;
+import net.minecraft.core.world.IVehicle;
 import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
@@ -1250,8 +1251,12 @@ public abstract class Player
     public void attackTargetEntityWithCurrentItem(@NotNull Entity entity) {
         if (!getGamemode().canInteract()) return;
 
-        int damage = 1;
         final @Nullable ItemStack currentItem = this.inventory.getCurrentItem();
+        if (entity == this.vehicle && entity.passesThroughRiderTargeting(currentItem)) {
+            return;
+        }
+
+        int damage = 1;
         if (currentItem != null) {
             damage = currentItem.getDamageVsEntity(entity);
         }
@@ -1660,34 +1665,38 @@ public abstract class Player
         float randomizedPitch = 0.8F + (this.world.rand.nextFloat() - this.world.rand.nextFloat()) * 0.45F;
 
         if (distance <= oneFifthOfRadius) {
-            this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+            player.playSoundToSelf(SoundCategory.WORLD_SOUNDS,
                 ventCoordinateX, ventCoordinateY, ventCoordinateZ,
             "tile.crumble", 20.0F, randomizedPitch);
             if(isNether) {
-                this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+                player.playSoundToSelf(SoundCategory.WORLD_SOUNDS,
                     ventCoordinateX, ventCoordinateY, ventCoordinateZ,
                 "tile.deepboom", 20.0F, randomizedPitch);
             }
         }
         else if (distance <= threeFifthsOfRadius) {
-            this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+            player.playSoundToSelf(SoundCategory.WORLD_SOUNDS,
                 ventCoordinateX, ventCoordinateY, ventCoordinateZ,
             "tile.deepcrumble", 20.0F, randomizedPitch);
             if(isNether) {
-                this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+                player.playSoundToSelf(SoundCategory.WORLD_SOUNDS,
                     ventCoordinateX, ventCoordinateY, ventCoordinateZ,
                 "tile.deepquietboom", 20.0F, randomizedPitch);
             }
         }
         else {
             if(isNether) {
-                this.world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS,
+                player.playSoundToSelf(SoundCategory.WORLD_SOUNDS,
                     ventCoordinateX, ventCoordinateY, ventCoordinateZ,
                 "tile.deepquietboom", 20.0F, randomizedPitch);
             }
         }
     }
 
+    public void playSoundToSelf(final SoundCategory category, final double x, final double y, final double z, final String soundPath, final float volume, final float pitch) {
+        this.world.playSoundEffect(null, category, x, y, z, soundPath, volume, pitch);
+    }
+
     @Override
     public boolean canBreatheUnderwater() {
         return this.gamemode.hasInvulnerablePlayer();
@@ -1728,6 +1737,14 @@ public abstract class Player
         }
     }
 
+    @Override
+    public void startRiding(IVehicle vehicle) {
+        super.startRiding(vehicle);
+        if (this.vehicle != null) {
+            setNoPhysics(false);
+        }
+    }
+
     public void setLastDeathPoint(TilePos lastDeathPos) {
         this.lastDeathPoint = lastDeathPos;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
index 030a7e430..1af656fe0 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerLeaves.java
@@ -34,6 +34,7 @@ public class ItemBlockLayerLeaves<T extends BlockLogicLayerLeaves> extends ItemB
         if ((result.data & 0xF) < 6) {
             result.data += 1;
         } else {
+            assert this.block.getLogic().fullBlock != null;
             result.block = this.block.getLogic().fullBlock;
             result.data &= ~0xF;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerSnow.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerSnow.java
new file mode 100644
index 000000000..16304898e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockLayerSnow.java
@@ -0,0 +1,44 @@
+package net.minecraft.core.item.block;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicLayerBase;
+import net.minecraft.core.block.BlockLogicLayerSnow;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+
+public class ItemBlockLayerSnow<T extends BlockLogicLayerSnow> extends ItemBlockLayer<T> {
+    public ItemBlockLayerSnow(@NotNull Block<T> block) {
+        super(block);
+    }
+
+    @Override
+    public boolean canAccumulateInto(
+        @NotNull ItemStack selfStack,
+        @NotNull Block<?> block, int data, @NotNull Side side, double xHit, double yHit
+    ) {
+        return block == this.block && !(yHit - (((data & BlockLogicLayerBase.MASK_HEIGHT) + 1) * 0.125) <= -0x1p-12);
+    }
+
+    @Override
+    public @NotNull BlockDataResult getAccumulationResult(
+        @NotNull ItemStack selfStack,
+        @NotNull World world, @Nullable Player player, @NotNull TilePosc tilePos,
+        @NotNull Side side, double xHit, double yHit,
+        @NotNull BlockDataResult result
+    ){
+        result.data |= BlockLogicLayerSnow.MASK_PERMANENT;
+        if ((result.data & BlockLogicLayerBase.MASK_HEIGHT) < 6) {
+            result.data += 1;
+        } else {
+            assert this.block.getLogic().fullBlock != null;
+            result.block = this.block.getLogic().fullBlock;
+            result.data = 0;
+        }
+        return result;
+    }
+}
